
FuseByteDict = {
				'OCDEN' 	: 'Enable On-Chip Debug (OCD)',
				'JTAGEN' 	: 'Enable JTAG',
				'SPIEN' 	: 'Enable Serial Program and Data Downloading',

				'WDTON'		: 'Wacth-dog Timer always on',

				'M103C'		: 'Atmega103 compability mode',
				'M161C'		: 'Atmega161 compability mode',

				'DWEN'		: 'Debug Wire enable',
				'SELFPRGEN'	: 'Self Programming enable', 
				'EESAVE' 	: 'EEPROM memory is preserved through the Chip Erase',

				'BOOTSZ1' 	: 'Select Boot Size',	
				'BOOTSZ0' 	: 'Select Boot Size',	
				'BOOTRST' 	: 'Reset Vector Enabled',
			
				'RSTDISBL'	: 'Reset pin Disabled',

				'BODLEVEL' 	: 'Brown out detector trigger level',
				'BODEN' 	: 'Brown out detector enable',
				'BODLEVEL2'	: 'Select Brown-out detection',
				'BODLEVEL1'	: 'Select Brown-out detection',
				
				'BODLEVEL0'	: 'Select Brown-out detection',
				
				'PLLCK'		: 'PLL Clock Start up time',
				'SUT1' 		: 'Select start-up time',
				'SUT0' 		: 'Select start-up time',

				'CKOPT' 	: 'Oscillator options',
				'CKSEL3' 	: 'Select clock source',
				'CKSEL2' 	: 'Select clock source',	
				'CKSEL1' 	: 'Select clock source',	
				'CKSEL0' 	: 'Select clock source',

				'CKOUT'		: 'Clock output',
				'CKDIV8'	: 'Divide clock by 8 internally',
				str(None)	: 'None'

				}		

#		dict = {		( 'series1','series2' ) :
#						   ( ( default_HighByte, FuseHighByteList ), 
#							 ( default_LowByte, FuseLowByteList ), 
#							 ( default_ExtByte, FuseExtendByteList ) ),

#						('tiny13', 'tiny26' ) :
#						  ( ( 0x11, FuseHighByteList ), 
#							( 0x55, FuseLowByteList ), 
#							( 0x12, FuseExtendByteList ) )	 	}
		

#	data from >>	http://palmavr.sourceforge.net/cgi-bin/fc.cgi				 


aSeries ={  		    ('mega8'):
						   ( ( 0x11, [ 'BOOTRST', 'BOOTSZ0', 'BOOTSZ1', 'EESAVE', 'CKOPT', 'SPIEN', 'WTDON', 'RSTDISBL' ] ), 
							 ( 0x55, [ 'CKSEL0', 'CKSEL1', 'CKSEL2', 'CKSEL3', 'SUT0', 'SUT1', 'BODEN','BODLEVEL' ] ), 
							 ( 0xFF, [ None, None, None, None, None, None, None, None ] ) ),
									
						('mega16', 'mega32' ):
						   ( ( 0x11, [ 'BOOTRST', 'BOOTSZ0', 'BOOTSZ1', 'EESAVE', 'CKOPT', 'SPIEN', 'JTAGEN', 'OCDEN' ] ), 
							 ( 0x55, [ 'CKSEL0', 'CKSEL1', 'CKSEL2', 'CKSEL3', 'SUT0', 'SUT1', 'BODEN','BODLEVEL' ] ), 
							 ( 0xFF, [ None, None, None, None, None, None, None, None ] ) ),
							 
						( 'mega64','mega128') :
						  ( ( 0x99, [ 'BOOTRST', 'BOOTSZ0',	'BOOTSZ1', 'EESAVE', 'CKOPT', 'SPIEN', 'JTAGEN', 'OCDEN' ] ), 
							( 0xC1, [ 'CKSEL0', 'CKSEL1', 'CKSEL2', 'CKSEL3', 'SUT0', 'SUT1', 'BODEN','BODLEVEL' ] ), 
							( 0xFF, [ 'WDTON', 'CompMode', None, None, None, None, None, None ] ) ),

						( 'mega162' ) :
						  ( ( 0x99, [ 'BOOTRST', 'BOOTSZ0',	'BOOTSZ1', 'EESAVE','WDTON', 'SPIEN', 'JTAGEN',	'OCDEN' ] ), 
							( 0x41, [ 'CKSEL0', 'CKSEL1', 'CKSEL2', 'CKSEL3', 'SUT0', 'SUT1', 'CKOUT','CKDIV8' ] ), 
							( 0xFF, [ None, 'BODLEVEL0', 'BODLEVEL1', 'BODLEVEL2', 'M161C', None, None, None ] ) ),

						( 'mega48' ) :
						   ( ( 0xDF, [ 'BODLEVEL0', 'BODELEVEL1', 'BODELEVEL2', 'EESAVE', 'WDTON', 'SPIEN', 'DWEN', 'RSTDISBEL' ] ),
							 ( 0x62, [ 'CKSEL0', 'CKSEL1', 'CKSEL2', 'CKSEL3', 'SUT0', 'SUT1', 'CKOUT','CKDIV8' ] ), 
							 ( 0xFF, [ 'SELFPRGEN', None, None, None, None, None, None, None ] ) ),	
						
						( 'mega88','mega168' ) :
						  ( ( 0xDF, [ 'BODLEVEL0', 'BODELEVEL1', 'BODELEVEL2', 'EESAVE', 'WDTON', 'SPIEN', 'DWEN', 'RSTDISBEL' ] ), 
							( 0x62, [ 'CKSEL0', 'CKSEL1', 'CKSEL2', 'CKSEL3', 'SUT0', 'SUT1', 'CKOUT','CKDIV8' ] ), 
							( 0xF9, [ 'BOOTRST', 'BOOTSZ0',	'BOOTSZ1', None, None, None, None, None ] ) ),
						
						( 'tiny13' ):
					  	  ( ( 0xFF, [ 'RSTDISBL','BODLEVEL0', 'BODELEVEL1', 'DWEN', 'SELFPRGEN', None, None, None ] ), 
							( 0x6A, [ 'CKSEL0', 'CKSEL1', 'SUT0', 'SUT1', 'CKDIV8', 'WDTON', 'EESAVE', 'SPIEN' ] ), 
							( 0xFF, [ None, None, None, None, None, None, None, None ] ) ),	
						
						( 'tiny26' ):
					  	  ( ( 0xF7, [ 'RSTDISBL','BODLEVEL', 'EESAVE', 'SPIEN', 'RSTDISBL', None, None, None ] ), 
							( 0xF9, [ 'CKSEL0', 'CKSEL1', 'CKSEL2', 'CKSEL3', 'SUT0', 'SUT1', 'CKOPT', 'PLLCK' ] ), 
							( 0xFF, [ None, None, None, None, None, None, None, None ] ) )
																																				  
					}

class aFuseByteDict:
	
	def __init__( self ):
		self.aseriesFuseByteDict = aSeries
		
		self.aseriesFuseByte = None						
		self._aseriesFuseByteValue = None
		
		self.aFusehighByteList = None
		self.aFuselowByteList = None
		self.aFuseextendByteList = None
		self.AllSeries = []	

	def findSeries( self, name ):
		#	look for series index
		for index, seriesIndex in enumerate( self.aseriesFuseByteDict.keys() ):
			if type( seriesIndex ) == tuple:
				for i in seriesIndex:
					self.AllSeries.append( i )
					if name == i:	
						self.index = index
			else:
				self.AllSeries.append( seriesIndex )
				if name == seriesIndex:	
					self.index = index
					
		self.AllSeries.sort()			
		self.selectSeriesIndex( self.index )
		
	def setName( self, name ):
		self.findSeries( name )

	def selectSeriesIndex( self, index ):

		self.aseriesFuseByte =  self.aseriesFuseByteDict.items()[index][0]					
		self._aseriesFuseByteValue =  self.aseriesFuseByteDict.items()[index][1]

		self.aFusehighByteList = self._aseriesFuseByteValue[0][1]
		self.aFuselowByteList = self._aseriesFuseByteValue[1][1]
		self.aFuseextendByteList = self._aseriesFuseByteValue[2][1]
		
		self.aFusehighDefaultByte = self._aseriesFuseByteValue[0][0]
		self.aFuselowDefaultByte = self._aseriesFuseByteValue[1][0]
		self.aFuseextendDefaultByte = self._aseriesFuseByteValue[2][0]
		




#a = aFuseByteDict()
#a.findSeries( 'tiny26' )



